

local scrollMakingTradeID = 1000003


do
	local skillList = {}
	local recipeList, trade

	--334	total recipes
	--352	total scrolls
	local scrollIDs = {
		-- [???????] = 80156, -- Enchant Cloak - Greater Stats can't find corresponding recipe
		-- [???????] = 38958, -- Enchant Weapon - Exceptional Intellect can't find corresponding recipe
		-- [???????] = 38941, -- Enchant Cloak - Greater Arcane Resistance can't find corresponding recipe
		-- [???????] = 38950, -- Enchant Cloak - Superior Frost Resistance can't find corresponding recipe
		-- [???????] = 38957, -- Enchant Weapon - Exceptional Striking can't find corresponding recipe
		-- [???????] = 5421, -- Fiery Blaze Enchantment can't find corresponding recipe
		-- [???????] = 38942, -- Enchant Cloak - Greater Shadow Resistance can't find corresponding recipe
		-- [???????] = 38982, -- Enchant Cloak - Superior Arcane Resistance can't find corresponding recipe
		-- [???????] = 38969, -- Enchant Cloak - Superior Fire Resistance can't find corresponding recipe
		-- [???????] = 79061, -- Enchant Weapon - Pandamonium can't find corresponding recipe
		-- [???????] = 38994, -- Enchant Weapon - Exceptional Healing can't find corresponding recipe
		-- [???????] = 38795, -- Enchant Cloak - Lesser Shadow Resistance can't find corresponding recipe
		-- [???????] = 38815, -- Enchant Cloak - Fire Resistance can't find corresponding recipe
		-- [???????] = 38907, -- Enchant Shield - Resistance can't find corresponding recipe
		-- [???????] = 38858, -- Enchant Cloak - Greater Resistance can't find corresponding recipe
		-- [???????] = 38915, -- Enchant Cloak - Major Resistance can't find corresponding recipe
		-- [???????] = 77276, -- Enchant Weapon - Ninja can't find corresponding recipe
		-- [???????] = 38891, -- Enchant Cloak - Greater Fire Resistance can't find corresponding recipe
		-- [???????] = 38892, -- Enchant Cloak - Greater Nature Resistance can't find corresponding recipe
		-- [???????] = 38996, -- Enchant Bracers - Major Healing can't find corresponding recipe
		-- [???????] = 80167, -- Enchant Shield - Stats can't find corresponding recipe
		-- [???????] = 80157, -- Enchant Cloak - Superior Stats can't find corresponding recipe
		-- [???????] = 80155, -- Enchant Cloak - Stats can't find corresponding recipe
		-- [???????] = 80154, -- Enchant Cloak - Lesser Stats can't find corresponding recipe
		-- [???????] = 80153, -- Enchant Cloak - Minor Stats can't find corresponding recipe
		-- [???????] = 38977, -- Enchant Cloak - Superior Shadow Resistance can't find corresponding recipe
		-- [???????] = 38843, -- Enchant Shield - Frost Resistance can't find corresponding recipe
		-- [???????] = 38983, -- Enchant Shield - Mighty Stamina can't find corresponding recipe
		-- [???????] = 38970, -- Enchant Gloves - Exceptional Healing can't find corresponding recipe
		-- [???????] = 38784, -- Enchant Cloak - Lesser Fire Resistance can't find corresponding recipe
		-- [???????] = 38770, -- Enchant Cloak - Minor Resistance can't find corresponding recipe
		-- [???????] = 38826, -- Enchant Cloak - Resistance can't find corresponding recipe
		-- [???????] = 38956, -- Enchant Cloak - Superior Nature Resistance can't find corresponding recipe
		-- [???????] = 89717, -- Enchant Bracer - Exceptional Strength (Scaling) can't find corresponding recipe
		-- [???????] = 80158, -- Enchant Shield - Lesser Stats can't find corresponding recipe
		[20023] = 38863, -- Enchant Boots - Greater Agility  (1)
		[13746] = 38825, -- Enchant Cloak - Greater Defense  (2)
		[44528] = 38966, -- Enchant Boots - Greater Fortitude  (3)
		[64579] = 46098, -- Enchant Weapon - Blood Draining  (4)
		[13693] = 38821, -- Enchant Weapon - Striking  (5)
		[47766] = 39002, -- Enchant Chest - Greater Dodge  (6)
		[60623] = 38986, -- Enchant Boots - Icewalker  (7)
		[130758] = 89737, -- Enchant Shield - Greater Parry  (8)
		[27913] = 38901, -- Enchant Bracer - Restore Mana Prime  (9)
		[62256] = 44947, -- Enchant Bracer - Major Stamina  (10)
		[23803] = 38883, -- Enchant Weapon - Mighty Spirit  (11)
		[27958] = 38912, -- Enchant Chest - Exceptional Mana  (12)
		[96262] = 68786, -- Enchant Bracer - Mighty Intellect  (13)
		[47898] = 39003, -- Enchant Cloak - Greater Speed  (14)
		[7859] = 38783, -- Enchant Bracer - Lesser Spirit  (15)
		[74254] = 52783, -- Enchant Gloves - Mighty Strength  (16)
		[96261] = 68785, -- Enchant Bracer - Major Strength  (17)
		[20009] = 38853, -- Enchant Bracer - Superior Spirit  (18)
		[104390] = 74704, -- Enchant Bracer - Exceptional Strength  (19)
		[27972] = 38920, -- Enchant Weapon - Potency  (20)
		[20010] = 38854, -- Enchant Bracer - Superior Strength  (21)
		[74247] = 52777, -- Enchant Cloak - Greater Critical Strike  (22)
		[34009] = 38945, -- Enchant Shield - Major Stamina  (23)
		[44492] = 38955, -- Enchant Chest - Mighty Health  (24)
		[47672] = 39001, -- Enchant Cloak - Mighty Stamina  (25)
		[13689] = 38820, -- Enchant Shield - Lesser Parry  (26)
		[44575] = 44815, -- Enchant Bracer - Greater Assault  (27)
		[27899] = 38897, -- Enchant Bracer - Brawn  (28)
		[74236] = 52769, -- Enchant Boots - Precision  (29)
		[27951] = 37603, -- Enchant Boots - Dexterity  (30)
		[46594] = 38999, -- Enchant Chest - Dodge  (31)
		[71692] = 50816, -- Enchant Gloves - Angler  (32)
		[104391] = 74705, -- Enchant Bracer - Greater Agility  (33)
		[13898] = 38838, -- Enchant Weapon - Fiery Weapon  (34)
		[7782] = 38778, -- Enchant Bracer - Minor Strength  (35)
		[27954] = 38910, -- Enchant Boots - Surefooted  (36)
		[44510] = 38963, -- Enchant Weapon - Exceptional Spirit  (37)
		[33994] = 38932, -- Enchant Gloves - Precise Strikes  (38)
		[25084] = 38894, -- Enchant Cloak - Subtlety  (39)
		[44489] = 38954, -- Enchant Shield - Dodge  (40)
		[60616] = 38971, -- Enchant Bracer - Assault  (41)
		[13905] = 38839, -- Enchant Shield - Greater Spirit  (42)
		[27905] = 38898, -- Enchant Bracer - Stats  (43)
		[74202] = 52753, -- Enchant Cloak - Intellect  (44)
		[74246] = 52776, -- Enchant Weapon - Landslide  (45)
		[13887] = 38836, -- Enchant Gloves - Strength  (46)
		[74212] = 52756, -- Enchant Gloves - Exceptional Strength  (47)
		[13858] = 38833, -- Enchant Chest - Superior Health  (48)
		[7857] = 38782, -- Enchant Chest - Health  (49)
		[60606] = 44449, -- Enchant Boots - Assault  (50)
		[13642] = 38809, -- Enchant Bracer - Spirit  (51)
		[104414] = 74718, -- Enchant Boots - Pandaren's Step  (52)
		[27914] = 38902, -- Enchant Bracer - Fortitude  (53)
		[33997] = 38935, -- Enchant Gloves - Major Spellpower  (54)
		[104404] = 74713, -- Enchant Cloak - Superior Critical Strike  (55)
		[33992] = 38930, -- Enchant Chest - Major Resilience  (56)
		[104397] = 74709, -- Enchant Chest - Superior Stamina  (57)
		[20013] = 38857, -- Enchant Gloves - Greater Strength  (58)
		[13501] = 38793, -- Enchant Bracer - Lesser Stamina  (59)
		[44621] = 38988, -- Enchant Weapon - Giant Slayer  (60)
		[13917] = 38841, -- Enchant Chest - Superior Mana  (61)
		[28004] = 38927, -- Enchant Weapon - Battlemaster  (62)
		[44598] = 38984, -- Enchant Bracer - Expertise  (63)
		[60714] = 44467, -- Enchant Weapon - Mighty Spellpower  (64)
		[27961] = 38914, -- Enchant Cloak - Major Armor  (65)
		[74220] = 52759, -- Enchant Gloves - Greater Expertise  (66)
		[46578] = 38998, -- Enchant Weapon - Deathfrost  (67)
		[44635] = 38997, -- Enchant Bracer - Greater Spellpower  (68)
		[27981] = 38923, -- Enchant Weapon - Sunfire  (69)
		[44513] = 38964, -- Enchant Gloves - Greater Assault  (70)
		[23802] = 38882, -- Enchant Bracer - Healing Power  (71)
		[20035] = 38874, -- Enchant 2H Weapon - Major Spirit  (72)
		[42974] = 38948, -- Enchant Weapon - Executioner  (73)
		[104417] = 74720, -- Enchant Gloves - Superior Expertise  (74)
		[23799] = 38879, -- Enchant Weapon - Strength  (75)
		[34001] = 38937, -- Enchant Bracer - Major Intellect  (76)
		[104392] = 74706, -- Enchant Chest - Super Resilience  (77)
		[27950] = 38909, -- Enchant Boots - Fortitude  (78)
		[74234] = 52767, -- Enchant Cloak - Protection  (79)
		[74226] = 52762, -- Enchant Shield - Mastery  (80)
		[47901] = 39006, -- Enchant Boots - Tuskarr's Vitality  (81)
		[13937] = 38845, -- Enchant 2H Weapon - Greater Impact  (82)
		[104442] = 74728, -- Enchant Weapon - River's Song  (83)
		[74192] = 52745, -- Enchant Cloak - Lesser Power  (84)
		[27967] = 38917, -- Enchant Weapon - Major Striking  (85)
		[44623] = 38989, -- Enchant Chest - Super Stats  (86)
		[74223] = 52760, -- Enchant Weapon - Hurricane  (87)
		[27971] = 38919, -- Enchant 2H Weapon - Savagery  (88)
		[74240] = 52773, -- Enchant Cloak - Greater Intellect  (89)
		[60653] = 44455, -- Enchant Shield - Greater Intellect  (90)
		[104416] = 74719, -- Enchant Gloves - Greater Haste  (91)
		[13915] = 38840, -- Enchant Weapon - Demonslaying  (92)
		[20034] = 38873, -- Enchant Weapon - Crusader  (93)
		[13661] = 38817, -- Enchant Bracer - Strength  (94)
		[34007] = 38943, -- Enchant Boots - Cat's Swiftness  (95)
		[44484] = 38951, -- Enchant Gloves - Expertise  (96)
		[74191] = 52744, -- Enchant Chest - Mighty Stats  (97)
		[13836] = 38830, -- Enchant Boots - Stamina  (98)
		[27917] = 38903, -- Enchant Bracer - Spellpower  (99)
		[44631] = 38993, -- Enchant Cloak - Shadow Armor  (100)
		[74199] = 52750, -- Enchant Boots - Haste  (101)
		[74200] = 52751, -- Enchant Chest - Stamina  (102)
		[13485] = 38792, -- Enchant Shield - Lesser Spirit  (103)
		[21931] = 38876, -- Enchant Weapon - Winter's Might  (104)
		[60692] = 44465, -- Enchant Chest - Powerful Stats  (105)
		[60609] = 44456, -- Enchant Cloak - Speed  (106)
		[104385] = 74701, -- Enchant Bracer - Major Dodge  (107)
		[104419] = 74721, -- Enchant Gloves - Super Strength  (108)
		[13653] = 38813, -- Enchant Weapon - Lesser Beastslayer  (109)
		[74225] = 52761, -- Enchant Weapon - Heartsong  (110)
		[47900] = 39005, -- Enchant Chest - Super Health  (111)
		[59621] = 44493, -- Enchant Weapon - Berserking  (112)
		[44633] = 38995, -- Enchant Weapon - Exceptional Agility  (113)
		[74230] = 52764, -- Enchant Cloak - Critical Strike  (114)
		[7428] = 38768, -- Enchant Bracer - Minor Dodge  (115)
		[13868] = 38834, -- Enchant Gloves - Advanced Herbalism  (116)
		[13378] = 38787, -- Enchant Shield - Minor Stamina  (117)
		[7793] = 38781, -- Enchant 2H Weapon - Lesser Intellect  (118)
		[25074] = 38887, -- Enchant Gloves - Frost Power  (119)
		[74235] = 52768, -- Enchant Off-Hand - Superior Intellect  (120)
		[74232] = 52766, -- Enchant Bracer - Precision  (121)
		[25072] = 38885, -- Enchant Gloves - Threat  (122)
		[13695] = 38822, -- Enchant 2H Weapon - Impact  (123)
		[104430] = 74725, -- Enchant Weapon - Elemental Force  (124)
		[13612] = 38800, -- Enchant Gloves - Mining  (125)
		[25079] = 38889, -- Enchant Gloves - Healing Power  (126)
		[59625] = 43987, -- Enchant Weapon - Black Magic  (127)
		[33996] = 72070, -- Enchant Gloves - Assault  (128)
		[74237] = 52770, -- Enchant Bracer - Exceptional Spirit  (129)
		[13626] = 38804, -- Enchant Chest - Minor Stats  (130)
		[7867] = 38786, -- Enchant Boots - Minor Agility  (131)
		[95471] = 68134, -- Enchant 2H Weapon - Mighty Agility  (132)
		[74197] = 52748, -- Enchant Weapon - Avalanche  (133)
		[23800] = 38880, -- Enchant Weapon - Agility  (134)
		[27948] = 38908, -- Enchant Boots - Vitality  (135)
		[104440] = 74727, -- Enchant Weapon - Colossus  (136)
		[104398] = 74710, -- Enchant Cloak - Accuracy  (137)
		[13617] = 38801, -- Enchant Gloves - Herbalism  (138)
		[27946] = 38906, -- Enchant Shield - Parry  (139)
		[104403] = 74712, -- Enchant Cloak - Superior Intellect  (140)
		[7863] = 38785, -- Enchant Boots - Minor Stamina  (141)
		[44508] = 38961, -- Enchant Boots - Greater Spirit  (142)
		[13620] = 38802, -- Enchant Gloves - Fishing  (143)
		[74252] = 52781, -- Enchant Boots - Assassin's Step  (144)
		[13529] = 38796, -- Enchant 2H Weapon - Lesser Impact  (145)
		[13648] = 38812, -- Enchant Bracer - Stamina  (146)
		[104434] = 74726, -- Enchant Weapon - Dancing Steel  (147)
		[13644] = 38810, -- Enchant Boots - Lesser Stamina  (148)
		[13607] = 38799, -- Enchant Chest - Mana  (149)
		[104401] = 74711, -- Enchant Cloak - Greater Protection  (150)
		[104407] = 74715, -- Enchant Boots - Greater Haste  (151)
		[7788] = 38780, -- Enchant Weapon - Minor Striking  (152)
		[47051] = 39000, -- Enchant Cloak - Greater Dodge  (153)
		[33991] = 38929, -- Enchant Chest - Restore Mana Prime  (154)
		[42620] = 38947, -- Enchant Weapon - Greater Agility  (155)
		[60668] = 44458, -- Enchant Gloves - Crusher  (156)
		[20015] = 38859, -- Enchant Cloak - Superior Defense  (157)
		[25086] = 38895, -- Enchant Cloak - Dodge  (158)
		[20032] = 38871, -- Enchant Weapon - Lifestealing  (159)
		[7748] = 38773, -- Enchant Chest - Lesser Health  (160)
		[44506] = 38960, -- Enchant Gloves - Gatherer  (161)
		[13941] = 38847, -- Enchant Chest - Stats  (162)
		[25083] = 38893, -- Enchant Cloak - Stealth  (163)
		[25080] = 38890, -- Enchant Gloves - Superior Agility  (164)
		[74132] = 52687, -- Enchant Gloves - Mastery  (165)
		[25078] = 38888, -- Enchant Gloves - Fire Power  (166)
		[34010] = 38946, -- Enchant Weapon - Major Healing  (167)
		[74250] = 52779, -- Enchant Chest - Peerless Stats  (168)
		[33995] = 38933, -- Enchant Gloves - Major Strength  (169)
		[20028] = 38867, -- Enchant Chest - Major Mana  (170)
		[20026] = 38866, -- Enchant Chest - Major Health  (171)
		[13948] = 38851, -- Enchant Gloves - Minor Haste  (172)
		[23804] = 38884, -- Enchant Weapon - Mighty Intellect  (173)
		[20025] = 38865, -- Enchant Chest - Greater Stats  (174)
		[20024] = 38864, -- Enchant Boots - Spirit  (175)
		[20020] = 38862, -- Enchant Boots - Greater Stamina  (176)
		[44588] = 38975, -- Enchant Chest - Exceptional Resilience  (177)
		[20017] = 38861, -- Enchant Shield - Greater Stamina  (178)
		[20012] = 38856, -- Enchant Gloves - Greater Agility  (179)
		[34003] = 38939, -- Enchant Cloak - Spell Penetration  (180)
		[27977] = 38922, -- Enchant 2H Weapon - Major Agility  (181)
		[34002] = 38938, -- Enchant Bracer - Lesser Assault  (182)
		[13817] = 38828, -- Enchant Shield - Stamina  (183)
		[13890] = 38837, -- Enchant Boots - Minor Speed  (184)
		[13947] = 38850, -- Enchant Gloves - Riding Skill  (185)
		[60621] = 44453, -- Enchant Weapon - Greater Potency  (186)
		[13939] = 38846, -- Enchant Bracer - Greater Strength  (187)
		[13935] = 38844, -- Enchant Boots - Agility  (188)
		[74193] = 52746, -- Enchant Bracer - Speed  (189)
		[13882] = 38835, -- Enchant Cloak - Lesser Agility  (190)
		[7786] = 38779, -- Enchant Weapon - Minor Beastslayer  (191)
		[20016] = 38860, -- Enchant Shield - Vitality  (192)
		[13931] = 38842, -- Enchant Bracer - Dodge  (193)
		[22749] = 38877, -- Enchant Weapon - Spellpower  (194)
		[20008] = 38852, -- Enchant Bracer - Greater Intellect  (195)
		[13846] = 38832, -- Enchant Bracer - Greater Spirit  (196)
		[33990] = 38928, -- Enchant Chest - Major Spirit  (197)
		[27975] = 38921, -- Enchant Weapon - Major Spellpower  (198)
		[13841] = 38831, -- Enchant Gloves - Advanced Mining  (199)
		[13538] = 38798, -- Enchant Chest - Lesser Absorption  (200)
		[20011] = 38855, -- Enchant Bracer - Superior Stamina  (201)
		[13815] = 38827, -- Enchant Gloves - Agility  (202)
		[44625] = 38990, -- Enchant Gloves - Armsman  (203)
		[7426] = 38767, -- Enchant Chest - Minor Absorption  (204)
		[44595] = 38981, -- Enchant 2H Weapon - Scourgebane  (205)
		[13687] = 38819, -- Enchant Boots - Lesser Spirit  (206)
		[13663] = 38818, -- Enchant Chest - Greater Mana  (207)
		[74255] = 52784, -- Enchant Gloves - Greater Mastery  (208)
		[13646] = 38811, -- Enchant Bracer - Lesser Dodge  (209)
		[13640] = 38808, -- Enchant Chest - Greater Health  (210)
		[47899] = 39004, -- Enchant Cloak - Wisdom  (211)
		[7418] = 38679, -- Enchant Bracer - Minor Health  (212)
		[7776] = 38776, -- Enchant Chest - Lesser Mana  (213)
		[13635] = 38806, -- Enchant Cloak - Defense  (214)
		[74253] = 52782, -- Enchant Boots - Lavawalker  (215)
		[13631] = 38805, -- Enchant Shield - Lesser Stamina  (216)
		[13622] = 38803, -- Enchant Bracer - Lesser Intellect  (217)
		[13822] = 38829, -- Enchant Bracer - Intellect  (218)
		[13536] = 38797, -- Enchant Bracer - Lesser Strength  (219)
		[74195] = 52747, -- Enchant Weapon - Mending  (220)
		[7779] = 38777, -- Enchant Bracer - Minor Agility  (221)
		[13421] = 38790, -- Enchant Cloak - Lesser Protection  (222)
		[44630] = 38992, -- Enchant 2H Weapon - Greater Savagery  (223)
		[25073] = 38886, -- Enchant Gloves - Shadow Power  (224)
		[27960] = 38913, -- Enchant Chest - Exceptional Stats  (225)
		[13464] = 38791, -- Enchant Shield - Lesser Protection  (226)
		[74231] = 52765, -- Enchant Chest - Exceptional Spirit  (227)
		[20029] = 38868, -- Enchant Weapon - Icy Chill  (228)
		[44576] = 38972, -- Enchant Weapon - Lifeward  (229)
		[74256] = 52785, -- Enchant Bracer - Greater Speed  (230)
		[13637] = 38807, -- Enchant Boots - Lesser Agility  (231)
		[104408] = 74716, -- Enchant Boots - Greater Precision  (232)
		[7771] = 38775, -- Enchant Cloak - Minor Protection  (233)
		[44383] = 38949, -- Enchant Shield - Resilience  (234)
		[74213] = 52757, -- Enchant Boots - Major Agility  (235)
		[7766] = 38774, -- Enchant Bracer - Minor Spirit  (236)
		[63746] = 45628, -- Enchant Boots - Lesser Accuracy  (237)
		[44509] = 38962, -- Enchant Chest - Greater Mana Restoration  (238)
		[104393] = 74707, -- Enchant Chest - Mighty Spirit  (239)
		[13943] = 38848, -- Enchant Weapon - Greater Striking  (240)
		[44555] = 38968, -- Enchant Bracer - Exceptional Intellect  (241)
		[104409] = 74717, -- Enchant Boots - Blurred Speed  (242)
		[7443] = 38769, -- Enchant Chest - Minor Mana  (243)
		[44529] = 38967, -- Enchant Gloves - Major Agility  (244)
		[13700] = 38824, -- Enchant Chest - Lesser Stats  (245)
		[27984] = 38925, -- Enchant Weapon - Mongoose  (246)
		[60691] = 44463, -- Enchant 2H Weapon - Massacre  (247)
		[44524] = 38965, -- Enchant Weapon - Icebreaker  (248)
		[74248] = 52778, -- Enchant Bracer - Greater Critical Strike  (249)
		[44616] = 38987, -- Enchant Bracer - Greater Stats  (250)
		[7420] = 38766, -- Enchant Chest - Minor Health  (251)
		[60707] = 44466, -- Enchant Weapon - Superior Potency  (252)
		[44582] = 38973, -- Enchant Cloak - Minor Power  (253)
		[44589] = 38976, -- Enchant Boots - Superior Agility  (254)
		[28003] = 38926, -- Enchant Weapon - Spellsurge  (255)
		[104395] = 74708, -- Enchant Chest - Glorious Stats  (256)
		[64441] = 46026, -- Enchant Weapon - Blade Ward  (257)
		[27837] = 38896, -- Enchant 2H Weapon - Agility  (258)
		[104389] = 74703, -- Enchant Bracer - Super Intellect  (259)
		[44488] = 38953, -- Enchant Gloves - Precision  (260)
		[60663] = 44457, -- Enchant Cloak - Major Agility  (261)
		[44592] = 38979, -- Enchant Gloves - Exceptional Spellpower  (262)
		[44629] = 38991, -- Enchant Weapon - Exceptional Spellpower  (263)
		[74229] = 52763, -- Enchant Bracer - Superior Dodge  (264)
		[13945] = 38849, -- Enchant Bracer - Greater Stamina  (265)
		[13380] = 38788, -- Enchant 2H Weapon - Lesser Spirit  (266)
		[74201] = 52752, -- Enchant Bracer - Critical Strike  (267)
		[44591] = 38978, -- Enchant Cloak - Superior Dodge  (268)
		[62948] = 45056, -- Enchant Staff - Greater Spellpower  (269)
		[13659] = 38816, -- Enchant Shield - Spirit  (270)
		[74198] = 52749, -- Enchant Gloves - Haste  (271)
		[34004] = 38940, -- Enchant Cloak - Greater Agility  (272)
		[20036] = 38875, -- Enchant 2H Weapon - Major Intellect  (273)
		[20033] = 38872, -- Enchant Weapon - Unholy Weapon  (274)
		[13698] = 38823, -- Enchant Gloves - Skinning  (275)
		[20031] = 38870, -- Enchant Weapon - Superior Striking  (276)
		[44593] = 38980, -- Enchant Bracer - Major Spirit  (277)
		[20030] = 38869, -- Enchant 2H Weapon - Superior Impact  (278)
		[7457] = 38771, -- Enchant Bracer - Minor Stamina  (279)
		[27911] = 38900, -- Enchant Bracer - Superior Healing  (280)
		[13419] = 38789, -- Enchant Cloak - Minor Agility  (281)
		[74244] = 52775, -- Enchant Weapon - Windwalk  (282)
		[34008] = 38944, -- Enchant Boots - Boar's Speed  (283)
		[59619] = 44497, -- Enchant Weapon - Accuracy  (284)
		[23801] = 38881, -- Enchant Bracer - Mana Regeneration  (285)
		[104338] = 74700, -- Enchant Bracer - Mastery  (286)
		[13655] = 38814, -- Enchant Weapon - Lesser Elemental Slayer  (287)
		[74239] = 52772, -- Enchant Bracer - Greater Expertise  (288)
		[104427] = 74724, -- Enchant Weapon - Jade Spirit  (289)
		[74251] = 52780, -- Enchant Chest - Greater Stamina  (290)
		[104445] = 74729, -- Enchant Off-Hand - Major Intellect  (291)
		[44584] = 38974, -- Enchant Boots - Greater Vitality  (292)
		[74214] = 52758, -- Enchant Chest - Mighty Resilience  (293)
		[7745] = 38772, -- Enchant 2H Weapon - Minor Impact  (294)
		[27968] = 38918, -- Enchant Weapon - Major Intellect  (295)
		[27906] = 38899, -- Enchant Bracer - Greater Dodge  (296)
		[13503] = 38794, -- Enchant Weapon - Lesser Striking  (297)
		[104420] = 74722, -- Enchant Gloves - Superior Mastery  (298)
		[33993] = 38931, -- Enchant Gloves - Blasting  (299)
		[104425] = 74723, -- Enchant Weapon - Windsong  (300)
		[33999] = 38936, -- Enchant Gloves - Major Healing  (301)
		[96264] = 68784, -- Enchant Bracer - Agility  (302)
		[27982] = 38924, -- Enchant Weapon - Soulfrost  (303)
		[27945] = 38905, -- Enchant Shield - Intellect  (304)
		[62959] = 45060, -- Enchant Staff - Spellpower  (305)
		[27944] = 38904, -- Enchant Shield - Lesser Dodge  (306)
		[74189] = 52743, -- Enchant Boots - Earthen Vitality  (307)
		[44500] = 38959, -- Enchant Cloak - Superior Agility  (308)
		[22750] = 38878, -- Enchant Weapon - Healing Power  (309)
		[74211] = 52755, -- Enchant Weapon - Elemental Slayer  (310)
		[60767] = 44470, -- Enchant Bracer - Superior Spellpower  (311)
		[60763] = 44469, -- Enchant Boots - Greater Assault  (312)
		[74242] = 52774, -- Enchant Weapon - Power Torrent  (313)
		[74238] = 52771, -- Enchant Boots - Mastery  (314)
		[27957] = 38911, -- Enchant Chest - Exceptional Health  (315)
		[74207] = 52754, -- Enchant Shield - Protection  (316)
	}
	local recipeLevels = {
		[0] = {20008,20016,20024,20032,13617,13637,13661,63746,13689,13693,23801,13817,25079,13841,20009,20025,20033,13378,13905,13917,13937,13941,13945,23802,64579,7779,7793,13538,25072,25080,20026,13622,13626,13642,13646,7857,7859,7863,7867,22749,13698,23803,44636,7418,7420,7426,7428,13822,25073,13846,20011,20035,13882,93841,13890,13419,22750,23804,27924,13503,25074,20012,20020,13607,13631,13635,13655,13659,13663,27837,13687,13695,64441,13815,25083,20013,20029,13887,13380,13915,59636,13931,13935,13939,13943,13947,13464,7766,7776,7782,13536,17180,20030,25084,20036,13612,13620,7745,13644,13648,13700,23799,27927,13746,13898,7771,7411,21931,20017,13485,13836,20023,7443,20015,74215,71692,13868,7457,13858,20010,20034,20031,74216,13421,13653,13948,7748,23800,17181,27920,74217,7786,13501,7788,13529,74218,44645,20028,13640,44506,25078,},
		[35] = {33996,27905,27913,27977,42620,33997,27906,27914,27954,33999,34001,34002,27948,27972,28004,34003,44383,34004,47051,27957,27981,33990,27950,27982,33991,34007,27944,27971,33992,27961,27911,27951,27899,27967,27975,33993,34009,27946,27945,33994,34010,28003,46594,27968,27984,27960,33995,27917,34008,25086,},
		[60] = {60616,44488,62948,44584,44616,44489,44633,60714,60763,42974,44555,44635,44492,44508,44524,47766,60621,60653,44509,44621,60606,44510,60623,60767,44623,44528,44576,44592,60609,59619,47898,44513,44529,44625,47899,27958,44589,59621,47900,60707,62256,60691,44630,44595,62959,44575,47672,44631,44484,44500,44591,44582,44593,44629,46578,60668,47901,60692,44598,44588,59625,60663,},
		[300] = {74252,74253,74254,74191,74192,74256,74193,74225,96262,74226,74195,74197,74229,74198,74199,74231,74200,74232,74201,74202,74234,74238,74207,95471,74211,74220,74247,74240,74230,74212,74132,74213,74235,74214,74246,74244,74251,74242,96261,74236,74189,74239,74248,96264,74223,74255,74250,74237,},
		[372] = {104338,104407,104408,104440,104442,104445,104414,104416,104385,104417,104419,103461,104420,103462,104389,104391,103465,104392,104404,104403,104393,104425,104401,104398,104395,104427,104409,104430,103463,104397,104390,104434,},
		[417] = {130758,},
	}
	local recipeSlots = {
		[5] = {7420,7426,7443,7748,7776,7857,13538,13607,13626,13640,13663,13700,13858,13917,13941,20025,20026,20028,27958,44492,44509,44588,44623,47766,47900,60692,104392,104393,104395,104397,27957,27960,33990,33991,33992,46594,74191,74200,74214,74231,74250,74251},
		[8] = {7863,7867,13637,13644,13687,13836,13890,13935,20020,20023,20024,63746,44508,44528,44584,44589,47901,60606,60623,60763,104407,104408,104409,104414,27948,27950,27951,27954,34007,34008,74189,74199,74213,74236,74238,74252,74253},
		[9] = {7418,7428,7457,7766,7779,7782,7859,13501,13536,13622,13642,13646,13648,13661,13822,13846,13931,13939,13945,20008,20009,20010,20011,23801,23802,44555,44575,44593,44598,44616,44635,60616,60767,62256,104338,104385,104389,104390,104391,27899,27905,27906,27911,27913,27914,27917,34001,34002,74193,74201,74229,74232,74237,74239,74248,74256,96261,96262,96264},
		[10] = {13612,13617,13620,13698,13815,13841,13868,13887,13947,13948,20012,20013,25072,25073,25074,25078,25079,25080,44506,71692,44484,44488,44513,44529,44592,44625,60668,104416,104417,104419,104420,33993,33994,33995,33996,33997,33999,74132,74198,74212,74220,74254,74255},
		[11] = {27920,27924,27927,44636,44645,59636,74215,74216,74217,74218,103461,103462,103463,103465},
		[13] = {7786,7788,13503,13653,13655,13693,13898,13915,13943,20029,20031,20032,20033,20034,21931,22749,22750,23799,23800,23803,23804,64441,64579,42974,44510,44524,44576,44621,44629,44633,46578,59619,59621,59625,60621,60707,60714,104425,104427,104430,104434,104440,104442,27967,27968,27972,27975,27981,27982,27984,28003,28004,34010,42620,74195,74197,74211,74223,74225,74242,74244,74246},
		[14] = {13378,13464,13485,13631,13659,13689,13817,13905,20016,20017,130758,44489,60653,104445,27944,27945,27946,34009,44383,74207,74226,74235},
		[16] = {7771,13419,13421,13635,13746,13882,20015,25083,25084,44500,44582,44591,44631,47672,47898,47899,60609,60663,104398,104401,104403,104404,25086,27961,34003,34004,47051,74192,74202,74230,74234,74240,74247},
		[17] = {7745,7786,7788,7793,13380,13503,13529,13653,13655,13693,13695,13898,13915,13937,13943,20029,20030,20031,20032,20033,20034,20035,20036,21931,22749,22750,23799,23800,23803,23804,27837,64441,64579,42974,44510,44524,44576,44595,44621,44629,44630,44633,46578,59619,59621,59625,60621,60691,60707,60714,62948,62959,104425,104427,104430,104434,104440,104442,27967,27968,27971,27972,27975,27977,27981,27982,27984,28003,28004,34010,42620,74195,74197,74211,74223,74225,74242,74244,74246,95471},
		[20] = {7411,7412,7413,7418,7420,7426,7428,7443,7457,7745,7748,7766,7771,7776,7779,7782,7786,7788,7793,7857,7859,7863,7867,13378,13380,13419,13421,13464,13485,13501,13503,13529,13536,13538,13607,13612,13617,13620,13622,13626,13631,13635,13637,13640,13642,13644,13646,13648,13653,13655,13659,13661,13663,13687,13689,13693,13695,13698,13700,13746,13815,13817,13822,13836,13841,13846,13858,13868,13882,13887,13890,13898,13905,13915,13917,13931,13935,13937,13939,13941,13943,13945,13947,13948,17180,17181,20008,20009,20010,20011,20012,20013,20015,20016,20017,20020,20023,20024,20025,20026,20028,20029,20030,20031,20032,20033,20034,20035,20036,21931,22749,22750,23799,23800,23801,23802,23803,23804,25072,25073,25074,25078,25079,25080,25083,25084,27837,27920,27924,27927,44506,44636,44645,59636,63746,64441,64579,71692,74215,74216,74217,74218,93841,130758,27958,42974,44484,44488,44489,44492,44500,44508,44509,44510,44513,44524,44528,44529,44555,44575,44576,44582,44584,44588,44589,44591,44592,44593,44595,44598,44616,44621,44623,44625,44629,44630,44631,44633,44635,46578,47672,47766,47898,47899,47900,47901,51313,59619,59621,59625,60606,60609,60616,60621,60623,60653,60663,60668,60691,60692,60707,60714,60763,60767,62256,62948,62959,74258,110400,103461,103462,103463,103465,104338,104385,104389,104390,104391,104392,104393,104395,104397,104398,104401,104403,104404,104407,104408,104409,104414,104416,104417,104419,104420,104425,104427,104430,104434,104440,104442,104445,13920,25086,27899,27905,27906,27911,27913,27914,27917,27944,27945,27946,27948,27950,27951,27954,27957,27960,27961,27967,27968,27971,27972,27975,27977,27981,27982,27984,28003,28004,28029,33990,33991,33992,33993,33994,33995,33996,33997,33999,34001,34002,34003,34004,34007,34008,34009,34010,42620,44383,46594,47051,74132,74189,74191,74192,74193,74195,74197,74198,74199,74200,74201,74202,74207,74211,74212,74213,74214,74220,74223,74225,74226,74229,74230,74231,74232,74234,74235,74236,74237,74238,74239,74240,74242,74244,74246,74247,74248,74250,74251,74252,74253,74254,74255,74256,95471,96261,96262,96264},
		[21] = {7786,7788,13503,13653,13655,13693,13898,13915,13943,20029,20031,20032,20033,20034,21931,22749,22750,23799,23800,23803,23804,64441,64579,42974,44510,44524,44576,44621,44629,44633,46578,59619,59621,59625,60621,60707,60714,104425,104427,104430,104434,104440,104442,27967,27968,27972,27975,27981,27982,27984,28003,28004,34010,42620,74195,74197,74211,74223,74225,74242,74244,74246},
		[22] = {7786,7788,13503,13653,13655,13693,13898,13915,13943,20029,20031,20032,20033,20034,21931,22749,22750,23799,23800,23803,23804,64441,64579,42974,44510,44524,44576,44621,44629,44633,46578,59619,59621,59625,60621,60707,60714,104425,104427,104430,104434,104440,104442,104445,27967,27968,27972,27975,27981,27982,27984,28003,28004,34010,42620,74195,74197,74211,74223,74225,74242,74244,74246},
		[23] = {104445,74235},
	}

	local slotNames = {
		[5] = INVTYPE_CHEST,
		[8] = INVTYPE_FEET,
		[9] = INVTYPE_WRIST,
		[10] = INVTYPE_HAND,
		[11] = INVTYPE_FINGER,
		[13] = INVTYPE_WEAPONMAINHAND,
		[14] = INVTYPE_SHIELD,
		[16] = INVTYPE_CLOAK,
		[17] = INVTYPE_2HWEAPON,
		[21] = INVTYPE_WEAPONMAINHAND,
		[22] = INVTYPE_WEAPONOFFHAND,
		[23] = INVTYPE_HOLDABLE,
	}


	local levelNames = {
		[0] = "No Level Restriction",
		[35] = "Requires Level 35+ Item",
		[60] = "Requires Level 60+ Item",
		[300] = "Requires Level 300+ Item",
		[372] = "Requires Level 372+ Item",
		[417] = "Requires Level 417+ Item",
	}


	local function ScrollMakingSpellID(enchantID)
		return enchantID+400000
	end

	local function ScrollMakingEnchantID(spellID)
		return spellID-400000
	end


	local reagents = {}
	local results = {}


	local api = {}




	local function AttachVellum()

		if GnomeWorks.isProcessing then
			UseItemByName(38682)
		end

		return true
	end



	local f = CreateFrame("Frame")

	f:RegisterEvent("UPDATE_TRADESKILL_RECAST")


	f:SetScript("OnEvent", function(frame,event)
		local count = GetTradeskillRepeatCount()

		if count > 0 then
			GnomeWorks:ScheduleTimer(AttachVellum, 1)

--			UseItemByName(38682)
		end
	end)

	f:Hide()




	api.SpellCastCheck = function(recipeID, spellID)
		local enchantID = ScrollMakingEnchantID(recipeID)
		if enchantID == spellID then
			return true
		end
	end


	api.DoTradeSkill = function(recipeID, count)
		CastSpellByName(GetSpellInfo(7411))

		local enchantID = ScrollMakingEnchantID(recipeID)
		local skillIndex = GnomeWorks:FindRecipeSkillIndex(enchantID)

		if skillIndex then
--			GnomeWorks:RegisterMessageDispatch("TradeProcessing", AttachVellum, "AttachVellum")

			DoTradeSkill(skillIndex, 1)
--			GnomeWorks:PickUpItem(38682)
			UseItemByName(38682)
		end
	end

	api.GetRecipeName = function(recipeID)
		local enchantID = ScrollMakingEnchantID(recipeID)
		local scrollID = scrollIDs[enchantID]

		return (GetItemInfo(scrollID))
	end

	api.GetRecipeData = function(recipeID)
		if results[recipeID] then
			return results[recipeID], reagents[recipeID], scrollMakingTradeID
		end
	end


	api.GetNumTradeSkills = function()
		return #skillList
	end

	api.GetTradeSkillItemLink = function(index)
		local recipeID = skillList[index]

		if recipeID then
			local enchantID = ScrollMakingEnchantID(recipeID)
			local scrollID = scrollIDs[enchantID]

			if scrollID then
				local _,link = GetItemInfo(scrollID)

				return link
			end
		end
	end

	api.GetTradeSkillRecipeLink = function(index)
		local recipeID = skillList[index]

		if recipeID then
			local enchantID = ScrollMakingEnchantID(recipeID)
			local scrollID = scrollIDs[enchantID]
			return "|cff80a0ff|Henchant:"..(recipeID or "nil").."|h["..(GetItemInfo(scrollID) or "nil").."]|h|r"
		end
	end


	api.GetTradeSkillLine = function()
		local rank, maxRank = GnomeWorks:GetTradeSkillRank(GnomeWorks.player, 7411)
		return "Scroll Making", rank, maxRank
	end

	api.GetTradeSkillInfo = function(index)
		local recipeID = skillList[index]

		return (recipeID and (GetItemInfo(recipeID))) or "nil", "optimal"
	end

	api.GetTradeSkillIcon = function(index)
		local recipeID = skillList[index]
		local enchantID = ScrollMakingEnchantID(recipeID)
		local scrollID = scrollIDs[enchantID]

		return GetItemIcon(scrollID)
	end

	api.IsTradeSkillLinked = function()
		return true
	end

--[[
	api.ConfigureMacroText = function(recipeID)
		local enchanting = GetSpellInfo(7411)
		local recipeName = \"..GetSpellInfo(ScrollMakingEnchantID(recipeID))..\"

		local castString = "/cast "..enchanting.."\r/script for i=1,1000 do if GetTradeSkillInfo(i)=="..recipeName.." then DoTradeSkill(i) break end end\r/use "..GetItemInfo(38682)

		return castString

--		return "/cast "..(GetSpellInfo(13262)).."\n/use "..GetItemInfo(next(deReagents[recipeID]))
	end
]]


	api.RecordKnownSpells = function(player)
		local knownSpells = GnomeWorks.data.knownSpells[player]

		if not knownSpells then return end

		for spellID in pairs(knownSpells) do
			if scrollIDs[spellID] and knownSpells[spellID] then
				local recipeID = ScrollMakingSpellID(scrollIDs[spellID])

				knownSpells[recipeID] = true
			end
		end
	end




	local function AddRecipe(trade,recipeID)
		local enchantResults, enchantReagents = GnomeWorks:GetRecipeData(recipeID)

		if enchantResults then
			local itemID,numMade = next(enchantResults)

			if itemID < 0 then
				local scrollName, scrollLink = GetItemInfo(itemID)

				if scrollLink then
					local scrollID = string.match(scrollLink, "item:(%d+)")

					if scrollID then
						local scrollRecipeID = ScrollMakingSpellID(enchantID)

						if GnomeWorksDB.recipeSkillLevels then
							for i = 1, 3 do
								GnomeWorksDB.recipeSkillLevels[i][scrollRecipeID] = GnomeWorksDB.recipeSkillLevels[i][enchantID]
							end
						end

						local enchantReagents = GnomeWorksDB.reagents[enchantID]

						if enchantReagents then
							skillList[#skillList +1] = scrollRecipeID

							recipeList[scrollRecipeID] = trade

							reagents[scrollRecipeID] = {}

							for itemID, numNeeded in pairs(enchantReagents) do
								reagents[scrollRecipeID][itemID] = numNeeded
								GnomeWorks:AddToReagentCache(itemID, scrollRecipeID, 1)
							end

							reagents[scrollRecipeID][38682] = 1
							results[scrollRecipeID] = { [scrollID] = 1 }

							GnomeWorks:AddToReagentCache(38682, scrollRecipeID, 1)
							GnomeWorks:AddToItemCache(scrollID, scrollRecipeID, 1)
						end
					end
				end
			end
		end
	end



	api.Scan = function()
		if not GnomeWorks.tradeID then
			return
		end

		local tradeID = GnomeWorks.tradeID
		local player = GnomeWorks.player

		local key = player..":"..tradeID

		local lastHeader = nil
		local gotNil = false

		local currentGroup = nil


		local slotGroup = GnomeWorks:RecipeGroupNew(player,tradeID,"By Slot")

		slotGroup.locked = true
		slotGroup.autoGroup = true

		GnomeWorks:RecipeGroupClearEntries(slotGroup)


		local levelGroup = GnomeWorks:RecipeGroupNew(player,tradeID,"By Level")

		levelGroup.locked = true
		levelGroup.autoGroup = true

		GnomeWorks:RecipeGroupClearEntries(levelGroup)



		local flatGroup = GnomeWorks:RecipeGroupNew(player,tradeID,"Flat")

		flatGroup.locked = true
		flatGroup.autoGroup = true

		GnomeWorks:RecipeGroupClearEntries(flatGroup)

--		local groupList = {}

--		local numHeaders = #reagentBrackets

		local knownSpells = GnomeWorks.data.knownSpells[player]

		for i = 1, #skillList, 1 do
			local subSpell, extra

			local recipeID = skillList[i]

			local enchantID = ScrollMakingEnchantID(recipeID)

			if knownSpells[enchantID] then
				knownSpells[recipeID] = true
				GnomeWorks:RecipeGroupAddRecipe(flatGroup, recipeID, i, true)

				for slot,recipeList in pairs(recipeSlots) do
					for k,spellID in ipairs(recipeList) do
						if spellID == enchantID then
							local groupName = slotNames[slot]

							local subGroup, newGroup = GnomeWorks:RecipeGroupNew(player,tradeID,"By Slot",groupName)

							GnomeWorks:RecipeGroupAddRecipe(subGroup, recipeID, i, true)

							if newGroup then
								GnomeWorks:RecipeGroupAddSubGroup(slotGroup, subGroup, i+1000, true)
							end
						end
					end
				end


				for level,recipeList in pairs(recipeLevels) do
					for k,spellID in ipairs(recipeList) do
						if spellID == enchantID then
							local groupName = levelNames[level]

							local subGroup, newGroup = GnomeWorks:RecipeGroupNew(player,tradeID,"By Level",groupName)

							GnomeWorks:RecipeGroupAddRecipe(subGroup, recipeID, i, true)

							if newGroup then
								GnomeWorks:RecipeGroupAddSubGroup(levelGroup, subGroup, i+1000, true)
							end
						end
					end
				end
			end
		end


		GnomeWorks:CraftabilityPurge()
		GnomeWorks:InventoryScan()

--		GnomeWorks:ScheduleTimer("UpdateMainWindow",.1)
		GnomeWorks:SendMessageDispatch("TradeScanComplete")
		return
	end




	local function SetUpRecipes(trade,recipeList)
		reagents = {}
		results = {}
		skillList = {}

		for enchantID, scrollID in pairs(scrollIDs) do
			local recipeID = ScrollMakingSpellID(enchantID)

			if GnomeWorksDB.recipeSkillLevels then
				for i = 1, 3 do
					GnomeWorksDB.recipeSkillLevels[i][recipeID] = GnomeWorksDB.recipeSkillLevels[i][enchantID]
				end
			end

			local enchantReagents = GnomeWorksDB.reagents[enchantID]

			if enchantReagents then
				skillList[#skillList +1] = recipeID

				recipeList[recipeID] = trade

				reagents[recipeID] = {}

				for itemID, numNeeded in pairs(enchantReagents) do
					reagents[recipeID][itemID] = numNeeded
					GnomeWorks:AddToReagentCache(itemID, recipeID, 1)
				end

				reagents[recipeID][38682] = 1
				results[recipeID] = { [scrollID] = 1 }

				GnomeWorks:AddToReagentCache(38682, recipeID, 1)
				GnomeWorks:AddToItemCache(scrollID, recipeID, 1)
			end
		end
	end

	api.GetTradeName = function()
		return "Scroll Making"
	end


	api.GetTradeLink = function()
		return "[Scroll Making]"
	end


	api.GetTradeIcon = function()
		return "Interface\\Icons\\INV_Scroll_07"
	end



	GnomeWorks:RegisterMessageDispatch("AddSpoofedRecipes", function ()
		local trade,recipeList  = GnomeWorks:AddPseudoTrade(scrollMakingTradeID,api)
		SetUpRecipes(trade,recipeList)
		trade.skillList = skillList

		GnomeWorks.system.levelBasis[scrollMakingTradeID] = 7411

		return true
	end)
end




